After you [build](https://docs.cloud.google.com/vision-ai/docs/build-app.md.txt) and [deploy](https://docs.cloud.google.com/vision-ai/docs/deploy-app.md.txt) apps, you can
manage these apps using the Google Cloud console or command line.

## Manage an application

## Update an app

#### Undeployed apps

Make any modifications to the app (such as adding or removing component nodes)
; Gemini Enterprise Agent Platform Vision will automatically store the changes.

#### Deployed apps

Changes to deployed apps are automatically stored to the Gemini Enterprise Agent Platform Vision server
and the deployed application is not affected. To discard modifications, click
the **Discard changes** button. To save changes, select
**Update the application**. To apply these local changes to the application,
undeploy the current application, then redeploy it.

## List apps

### REST

To list all apps in a project, send a GET request by using the
[projects.locations.applications.list](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.applications/list.md.txt)
method.


Before using any of the request data,
make the following replacements:

- <var translate="no">PROJECT</var>: Your Google Cloud [project ID or
  project number](https://docs.cloud.google.com/resource-manager/docs/creating-managing-projects#identifying_projects).
- <var translate="no">LOCATION_ID</var>: The [region](https://cloud.google.com/about/locations) where you are using Agent Platform Vision. For example: `us-central1`, `europe-west4`. See [available regions](https://docs.cloud.google.com/vision-ai/docs/warehouse-supported-regions.md.txt).


HTTP method and URL:

```
GET https://visionai.googleapis.com/v1/projects/PROJECT_NUMBER/locations/LOCATION_ID/applications
```

To send your request, choose one of these options:

#### curl

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Execute the following command:

```
curl -X GET \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     "https://visionai.googleapis.com/v1/projects/PROJECT_NUMBER/locations/LOCATION_ID/applications"
```

#### PowerShell

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method GET `
    -Headers $headers `
    -Uri "https://visionai.googleapis.com/v1/projects/PROJECT_NUMBER/locations/LOCATION_ID/applications" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

```
{
  "applications": [
    {
      "name": "projects/PROJECT_NUMBER/locations/LOCATION_ID/applications/test-application-1",
      "createTime": "2022-03-01T20:04:12.558371402Z",
      "updateTime": "2022-03-01T20:07:21.589713094Z",
      "displayName": "Test Application 1",
      "runtimeInfo": {
        "deployTime": "2022-03-01T20:07:21.460654Z"
      }
      "state": "DEPLOYED"
    },
    {
      "name": "projects/PROJECT_NUMBER/locations/LOCATION_ID/applications/test-application-2",
      "createTime": "2022-03-01T20:04:12.558371402Z",
      "updateTime": "2022-03-01T20:07:21.589713094Z",
      "displayName": "Test Application 2",
      "runtimeInfo": {
        "deployTime": "2022-03-01T20:07:21.460654Z"
      }
      "state": "DEPLOYED"
    },
  ]
}
```

<br />

<br />

## What's next

- Learn how to read app input data from an ingestion stream or analyzed model output data in [Read stream data](https://docs.cloud.google.com/vision-ai/docs/read-stream.md.txt).